2019-10-24  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	3.24.2

2019-10-24  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Makefile.am: Don't distribute PORTING

2019-10-24  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Remove PORTING

	It's obsolete and does not contain any useful information.

2019-09-18  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gtk::Builder docs: Describe how to use together with Glib::Property

2019-08-13  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	demos: Fix the source code listing

2019-08-12  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gdk::PixbufAnimation[Iter]: Disable warnings from deprecated GTimeVal

	GTimeVal has been deprecated in glib. Methods that use GTimeVal or
	Glib::TimeVal can't be deprecated in the stable gtkmm-3-24 branch now.
	This patch makes it possible to build gtkmm-3.24.x against the newest glib.

2019-07-24  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gtk: Fix ownership of some GLists

	* gtk/src/icontheme.ccg: list_icons(): Glib::OWNERSHIP_SHALLOW -> DEEP
	* gtk/src/iconview.hg: get_selected_icons(): SHALLOW -> DEEP. Remove the
	TreePathTraits struct in iconview.hg. Use the one in treepath.hg.
	* gtk/src/recentmanager.hg: get_items(): SHALLOW -> DEEP

2019-06-20  Daniel Boles  <dboles.src@gmail.com>

	Window: Do not add 2nd ref to new Cairo::Surface

	The C functions already return a newly allocated objected that the
	caller owns, so if we pass `false` as Cairo's `has_reference`, then we
	add another on the gtkmm side, so we will end up leaking that object.

	https://gitlab.gnome.org/GNOME/gtkmm/merge_requests/19#note_535429

2019-06-20  Daniel Boles  <dboles.src@gmail.com>

	Cursor: Fix meaning of comment about Cairo ref arg

	Cairo::Object takes a has_reference parameter, not take_copy with
	inverted meaning as in glibmm/gtkmm.

	Say "do not take ref" like e.g. window.hg already did, which is a bit
	clearer than has_reference (when does it get that? before or after us?)

	https://gitlab.gnome.org/GNOME/gtkmm/merge_requests/19#note_535429
	https://gitlab.gnome.org/GNOME/gtkmm/merge_requests/19#note_536603

2019-03-20  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	3.24.1

2019-03-20  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	configure.ac: Copy COPYING from the source directory

2019-01-08  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gtk::FileFilter: Don't use /* in a comment starting with /*

	Compilation error: "/*" within comment [-Werror=comment]

2019-01-07  Daniel Boles  <dboles.src@gmail.com>

	FileFilter: Remove commented-out _WRAP_METHOD call

	and remove the TODO: from the comment explaining it as it's already done

	https://gitlab.gnome.org/GNOME/gtkmm/merge_requests/12#note_396983

2019-01-07  Daniel Boles  <dboles.src@gmail.com>

	FileFilter: Don’t mention unwrapped func .filter()

	We specifically ignore this, so we shouldn’t point to it from the intro…

2019-01-07  Daniel Boles  <dboles.src@gmail.com>

	FileFilter: Fix no documentation of custom rules

	It is never very nice to see no documentation on our side and have to go
	and read the GTK documentation and hope it relates well enough to gtkmm.

2019-01-07  Daniel Boles  <dboles.src@gmail.com>

	FileFilter: Format docs copied in from GTK better

	Capitalise MIME, and put <tt> tags around the MIME types.

2018-12-29  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	tools/gen_scripts: Update for non-source-dir builds

	Most modules (e.g. gtk+) can be built in a directory separated from the
	source directory. Update the scripts that generate .defs and docs.xml files
	to handle that. See !11.
	The environment variable JHBUILD_SOURCES is not used any more.
	Instead the environment variables GMMPROC_GEN_SOURCE_DIR and
	GMMPROC_GEN_BUILD_DIR are read. See comments in init_generate.sh.

2018-12-18  Daniel Boles  <dboles@src.gnome.org>

	Gdk::RGBA: Add fairly simple test of our additions

	Test the fix for #42 and some other bits that we add. Most other tests
	should be added to GTK itself, not gtkmm.

	https://gitlab.gnome.org/GNOME/gtkmm/merge_requests/8#note_389465

2018-12-18  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	RGBA.set_hsv(): Properly interpret hue 360° as red

	(bug found and commit message by Daniel Boles; patch proposed by Kjell)

	We document an inclusive range of 0..360 degrees, but we divide by 60
	and switch over that, only handling 6 cases. So, hue 360° got treated as
	300° i.e. magenta, when instead it should be equivalent to 0° i.e. red.

	The simplest fix is this proposed by Kjell: to treat case i == 6 (360° /
	60°) the same as case i == 0, thereby making 360° red hue just like 0°.

	This exists only to achieve that; do not pass values outwith 0 <= h <=
	360 and expect anything but UB, as we document/assume that range only.

	closes https://gitlab.gnome.org/GNOME/gtkmm/issues/42

2018-12-17  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gtk::LevelBar: Don't let the copyright text be a Doxygen comment

	The copyright and license text started with "/**" which made Doxygen regard
	it as a description of the Gtk namespace.

2018-12-17  Daniel Boles  <dboles@src.gnome.org>

	Builder: Use refBuilder-> not refXml-> in examples

	It's much less clear what refXml is when we could just say refBuilder,
	as we already do elsewhere.

2018-12-16  Daniel Boles  <dboles@src.gnome.org>

	Builder: Fix wrong use of @retval for output args:

	@retval is for documenting the meanings of particular values of the
	returned variable, not output reference/pointer arguments like this.

2018-12-11  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Docs: Allow @newin with micro version, @newin{1,2,3}

2018-11-08  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	3.24.0

2018-11-08  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gtk::FileChooserDialog: Allow constructing with use-header-bar

	This is a construct-only property, so it must be specified in a constructor.
	Bug #780004 (Daniel Boles)

2018-11-07  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Add Gtk::NativeDialog and Gtk::FileChooserNative

	Bug 783801

2018-11-07  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Regenerate gtk_signals.defs

	Bug 783801

2018-11-07  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	generate_defs_gtk.cc: Add NativeDialog and FileChooserNative

	Bug 783801

2018-11-07  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	demos: Fix minor bug at a call to Gtk::make_managed()

	The newly introduced calls to make_managed() contained a bug.

2018-11-04  Murray Cumming  <murrayc@murrayc.com>

	Gtk::AboutDialog: Add constructor with a use_header_bar parameter

	Bug #780004 (Daniel Boles)

2018-11-04  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gdk::GLContext: Add unset_use_es()

	Bug #787898

2018-11-04  Daniel Boles  <dboles.src@gmail.com>

	Gtk::Window: Wrap gtk_show_uri_on_window()

	This is a very useful function that gtkmm did not wrap until now.

	https://bugzilla.gnome.org/show_bug.cgi?id=787242

2018-10-26  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	configure.ac: Update bug report address

2018-10-25  Chun-wei Fan  <fanchunwei@src.gnome.org>

	MSVC_NMake/config-msvc.mak: Use $(PDBVER) in DLL names

	Since this is the C++-11 version of gtkmm which supports both Visual
	Studio 2015 and 2017, we want to name the DLL and .lib to be like
	<library>-vc140-3_0.[dll.lib] or <library>-vc140-d-3_0.[dll|lib] since
	they both link to the v140 Windows C/C++ runtime DLLs, and thus these
	DLLs and .lib's are advertised to be interoperable, as supported by
	Microsoft.

	Note that the master branch, which requires C++-17, is not changed
	as Visual Studio 2017 is really required to build things there.

2018-10-23  Daniel Boles  <dboles.src@gmail.com>

	MenuItem: Fix typo altough => although

2018-10-20  Daniel Boles  <dboles.src@gmail.com>

	Container: ForeachSlot takes Widget&, not Widget*

	Fix the example, and while here, add an introductory line for the type,
	and mirror master in putting a line <br>eak between the text and code.

2018-10-07  Daniel Boles  <dboles.src@gmail.com>

	object: Add Gtk::make_managed<T>(args...) helper

	To avoid the discouraged pattern of manually writing `new` and get
	tidier syntax, follow the example of std::make_(unique|shared)() by
	adding a new helper function that both constructs and manages a widget
	in one call. The user will not need to `new` and can user fewer parens.

	auto button = Gtk::manage(new Gtk::Button("_Hi", true));

	becomes

	auto button = Gtk::make_managed<Gtk::Button>("_Hi", true);

	Switch to make_managed() in tests and demo, albeit nowhere else (yet?).

	https://gitlab.gnome.org/GNOME/gtkmm/issues/33

2018-10-07  Daniel Boles  <dboles.src@gmail.com>

	gtk-demo/demowindow: Avoid compiler warning by g++

	Flip the if/else case so that the /* Fall through */ comment comes
	before the next case label, which suppresses a warning from
	-Wimplicit-fallthrough and looks clearer anyway.

2018-10-07  Daniel Boles  <dboles.src@gmail.com>

	Image: Fix a typo

2018-09-08  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gtk: Add detail_name to some _WRAP_SIGNAL()s

	* gtk/src/accelgroup.hg: Add detail_name to signal_accel_changed().
	Deprecate signal_accel_activate(), which should never have been wrapped.
	* gtk/src/appchooserbutton.hg: signal_custom_item_activated().
	* gtk/src/levelbar.hg: signal_offset_changed().
	* gtk/src/widget.hg: signal_child_notify().

2018-09-08  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gtk::Range, Settings: Update some deprecations

	* gtk/src/range.hg: Deprecate property_[lower|upper]_stepper_sensitivity().
	* gtk/src/settings.hg: Undeprecate property_gtk_cursor_blink(),
	property_gtk_cursor_blink_time(),property_gtk_cursor_blink_timeout(),
	property_gtk_entry_password_hint_timeout().

2018-09-08  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gdk, Gtk: Regenerate docs.xml and .defs files

	and update gtk_signals.defs.patch.

2018-09-08  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Add tools/gen_scripts/generate_docs_and_defs.sh

2018-09-08  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Fix the generation of reference documentation

	* docs/Makefile.am: Include the filelist.gmake.am files.
	* gdk/gdkmm/filelist.gmake.am:
	* gdk/src/filelist.gmake.am:
	* gtk/gtkmm/filelist.gmake.am:
	* gtk/src/filelist.gmake.am: The search path of the filelist.am files
	start from $(top_srcdir) instead of $(srcdir). Necessary when the
	filelist.gmake.am files are included in docs/Makefile.am.

2018-09-07  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Update .gitignore

2018-09-07  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	docs_override.xml files: Add substitute_[type|enumerator]_name elements

	* gdk/src/gdk_docs_override.xml:
	* gtk/src/gtk_docs_override.xml: Applicable substitute_type_name and
	substitute_enumerator_name elements have been copied from the corresponding
	files in the master branch (gtkmm-4). Fixes #19

2018-09-07  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	configure.ac: Require giomm-2.4 >= 2.54.0

	Glibmm 2.54.0 introduces useful features in gmmproc:
	- Accept curly braces in default values in _WRAP macros.
	- Add new element types for the docs_override.xml files:
	substitute_type_name and substitute_enumerator_name.
	And more.

2018-09-07  Chun-wei Fan  <fanchunwei@src.gnome.org>

	build: Remove Visual Studio 2013 projects

	Since the NMake Makefiles replaced the Visual Studio projects, this
	commit drops them.

2018-09-07  Chun-wei Fan  <fanchunwei@src.gnome.org>

	build: Add NMake Makefiles for Visual Studio builds

	This adds NMake Makefiles for Visual Studio 2013 and later, which will
	replace the Visual Studio projects.  The main motivation for this is to
	ease maintenace on the Visual Studio build files, especially as sources
	are often added or removed, making the project files out-of-date as they
	are not generated during 'dist make'.  This will share the various
	filelist.am's so that any additions or removal of sources can be
	reflected upon the Visual Studio builds immediately.

	Note that as some code in the demos require compiler features that is
	only available in Visual Studio 2015 or later, we only build the demos
	if Visual Studio 2015 or later is used.

2018-09-07  Chun-wei Fan  <fanchunwei@src.gnome.org>

	build: Remove GNU Makeisms from filelist.am's

	This is so that they can be used by the NMake Makefiles as well.

2018-09-07  Chun-wei Fan  <fanchunwei@src.gnome.org>

	gendef: Skip CRT symbols that are implemented inline

	As a result to the move of UCRT for Visual Studio 2015 and later, some
	of the CRT functions are no longer done in the CRT DLL, but are instead
	implemented directly in the CRT headers.  We need to filter out these
	symbols so that we can link the gtkmm DLL properly.

	Unfortunately we cannot just link to legacy_stdio_definitions.lib to
	resolve this, so we just have to strip these symbols out from the
	generated gtkmm.def.

2018-09-07  Chun-wei Fan  <fanchunwei@src.gnome.org>

	build: Rename MSVC_Net2013 to MSVC_NMake

	This prepares for the transition to NMake Makefiles for the Visual Studio
	build system, which aims to reduce the likelihood of it becoming outdated
	as it shares the filelist.am's with the autotools build system, instead
	of being manually updated.

2018-08-29  Luca Bacci  <luca.bacci982@gmail.com>

	Document Gtk::CSsProviderError as @newin{3,16}

2018-08-24  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gtk::Widget: The show-all API is not deprecated in gtk+ any more

	Remove the G_GNUC_[BEGIN,END]_IGNORE_DEPRECATIONS around the show_all
	methods.
	See https://gitlab.gnome.org/GNOME/gtk/commit/da8994f941460206106255112ebe7dcd36b83065
	and https://gitlab.gnome.org/GNOME/gtk/issues/1282

2018-08-24  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gtk:MenuItem, Menus demo: Avoid the deprecated get_accel_group()

	* demos/gtk-demo/example_menus.cc: Don't use Gtk::Window::get_accel_group().
	* gtk/src/menuitem.ccg: accelerate(): Don't use get_accel_group(), if
	gtkmm is built without deprecated API. See issue #18

2018-08-24  Daniel Boles  <dboles@src.gnome.org>

	Gtk::Window: Move to a proper get_accel_groups()

	The existing get_accel_group() just creates a per-window AccelGroup on
	demand and returns it. That’s no use if you need groups that were added
	by other sources, e.g. by Gtk::Builder, Glade, etc.

	Deprecate that, in favour of a new get_accel_groups(), which wraps
	gtk_accel_groups_from_object() to return the actual set of AccelGroups.

	Note that gtk_accel_groups_from_object() takes a GObject, which it says
	is usually a GtkWindow. I therefore assume users will only want to get
	groups from a Window.

	While here:
	- Add a . to the Doxygen comment to tell it the 1st line is a summary
	- Don’t say the default group can’t be removed; I see no reason why not
	- Remove speculative comments on the old code, now explained elsewhere.

	Fixes #18

2018-08-23  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gtk::Image: Add more constructors

	Add 3 constructors, taking an icon name, a Gio::Icon and a Cairo::Surface,
	respectively.

	Fixes issue #35

2018-08-22  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Pixbufs demo: Use Gdk::FrameClock

	The corresponding demo in gtk+ uses GdkFrameClock.

	Also, make the pixbufs demo in gtkmm more C++'ish by minimizing the use
	of #define and using math functions from <cmath> instead of <math.h>.

2018-08-22  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gdk::Window, Gtk::StyleContext, Widget: Add FrameClock API

	* gdk/src/window.[ccg|hg]: Add get_frame_clock().
	* gtk/src/stylecontext.[ccg|hg]: Add set/get_frame_clock() and
	property_paint_clock().
	* gtk/src/widget.[ccg|hg]: Add get_frame_clock(), add_tick_callback() and
	remove_tick_callback().

2018-08-22  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Add Gdk::FrameClock and Gdk::FrameTimings

	* gdk/src/frameclock.[ccg|hg]:
	* gdk/src/frametimings.[ccg|hg]: New files.
	* .gitignore:
	* gdk/gdkmm.h:
	* gdk/src/filelist.am: Add new filenames.
	* gdk/src/gdk_extra_objects.defs: Add new objects.
	* gdk/src/gdk_signals.defs: Add GdkFrameClock's signals.
	* tools/extra_defs_gen/generate_defs_gdk.cc: Add GDK_TYPE_FRAME_CLOCK.
	* tools/m4/convert_gdk.m: Add conversions for GdkFrameClock and
	GdkFrameTimings.

	Fixes #23

2018-08-21  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Add Gdk::Cairo::create_surface_from_pixbuf()

	and Gdk::Cairo::get_clip_rectangle(), create_region_from_surface(),
	draw_from_gl(). Fixes #25

2018-08-20  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gtk::Grid: Add default values in attach()

	Add default value = 1 for the width and height parameters in attach() and
	attach_next_to(). Fixes #20

2018-08-19  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gtk::Container: Deprecate focus chains

	gtk_container_[set,unset,get]_focus_chain() have been deprecated
	in branch gtk-3-24.

2018-08-19  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gtk::Widget: Don't deprecate the show-all API

	The show-all API has been deprecated in gtk+ 3.24, but that may have been
	a premature action. It's still used in many gtk+ demo programs.
	Add G_GNUC_[BEGIN,END]_IGNORE_DEPRECATIONS to be able to use the deprecated
	gtk+ functions in non-deprecated gtkmm methods.

2018-08-19  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gtk::StyleContext: Deprecate render_frame_gap()

	gtk_render_frame_gap() has been deprecated in branch gtk-3-24.

2018-08-19  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gtk::CssProvider: Deprecate get_default()

	gtk_css_provider_get_default() has been deprecated in branch gtk-3-24.

2018-04-04  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Update the Menus demo

	Don't mention the deprecated ImageMenuItem in the description.
	Show the menu with accelerator keys.

2018-02-11  Christian Schoenebeck  <schoenebeck@linuxsampler.org>

	Gtk::MenuItem: Fix add_accel_label()

	Make sure accelator keys are shown, by calling gtk_menu_item_set_label().

	https://mail.gnome.org/archives/gtkmm-list/2018-February/msg00006.html

2018-01-24  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Fix the Change Display demo

	Make the demo more like the corresponding demo in gtk+, e.g. by using
	Gdk::Seat::grab() and Gdk::Device::get_window_at_position().

2017-12-28  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gdk: Deprecate flush(), screen_width(), etc.

	* gdk/gdkmm/general.[cc|h]: Decrecate Gdk::screen_width(), screen_height(),
	screen_width_mm(), screen_height_mm(), flush(). They have been deprecated
	in gtk+ 3.22.
	* gtk/src/fontbutton.hg: Disable deprecation warnings when fontbutton.cc
	is compiled. gtk_font_button_set/get_font_name() and property font-name
	are deprecated in gtk+ 3.22 in favor of gtk_font_chooser_set/get_font() and
	GtkFontChooser:font. They can't be deprecated in gtkmm 3.22 because
	FontChooser is not a base class of FontButton.
	* demos/gtk-demo/example_change_display.cc: Don't use the deprecated
	Gdk::flush().

2017-10-27  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gtk::AboutDialog::get_logo(): Add refreturn

2017-10-13  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Add a specialization for Glib::Value<Cairo::RefPtr<Cairo::Surface>>

	* gtk/src/cellrendererpixbuf.hg: Add a specialization for
	Glib::Value<Cairo::RefPtr<Cairo::Surface>>. A specialization for
	Glib::Value<Cairo::RefPtr<T>> can't be put in glibmm, because glibmm does
	not depend on cairomm. It can't be put in cairomm, because cairomm does
	not depend on glibmm. It's needed for property_surface(). Bug 788513

2017-10-09  Daniel Boles  <dboles.src@gmail.com>

	class_gtkobject.m4|object.h: Fix GtkObject→GObject

	GtkObject was moved down to the GLib level, as GObject, 2 versions ago.

	https://bugzilla.gnome.org/show_bug.cgi?id=788587

2017-09-13  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Update build/.gitignore

2017-09-13  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	tools/gen_scripts/: Update for gdk-pixbuf built with meson, and for gtk+-3

	When gdk-pixbuf is built with meson instead of autotools, generated .h
	and .c files are stored in gdk-pixbuf/build/gdk-pixbuf. Files in that
	directory shall be read when the docs.xml and the .defs files are generated.

	Read .h and .c files from the gtk+-3 directory.

2017-09-13  Murray Cumming  <murrayc@murrayc.com>

	3.22.2

2017-07-11  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gtk::PrintJob: Fix a call to Glib::throw_exception()

	Glib::throw_exception(GError*) takes ownership of the GError.
	SignalProxy_Custom_gtk_callback() must give a copy to throw_exception().

2017-07-06  Daniel Boles  <dboles@src.gnome.org>

	Gdk::RGBA: Update ctor(ustring) docs from GTK+

	https://bugzilla.gnome.org/show_bug.cgi?id=784483

2017-06-27  Kjell Ahlstedt  <kjellahlstedt@gmail.com>

	Gtk::Editable, RecentChooser, Scale: Fix memory leaks

	Editable::get_chars_vfunc(), RecentChooser::get_current_uri_vfunc() and
	Scale::signal_format_value() shall delete the returned character array
	after it has been copied to a Glib::ustring. Bug 783360

2017-06-23  Murray Cumming  <murrayc@murrayc.com>

	3.22.1

2017-06-03  Daniel Boles  <dboles@src.gnome.org>

	convert_gtk.m4: Remove redundant conversions

	These are already defined in convert_glib.m4, which is included as-is.

	https://bugzilla.gnome.org/show_bug.cgi?id=783136

2017-06-03  Daniel Boles  <dboles.src@gmail.com>

	gtk-demo/demowindow: Remove unnecessary null check

	There is no way that the pointer d can become null here.

2017-05-26  Daniel Boles  <dboles.src@gmail.com>

	gtk-demo: Use #include <blah> for system headers

	including our own and those from the stdlibs. This is more idiomatic, so
	it makes for better example code to show users.

2017-05-26  Daniel Boles  <dboles.src@gmail.com>

	gtk-demo/example_headerbar: Remove an old comment

	Nearly 3 years later, I think we can safely assume these icons are
	available on the end-user’s system.

2017-05-26  Daniel Boles  <dboles@src.gnome.org>

	gtk-demo/demowindow: Order #includes correctly

	in the spirit of
	https://git.gnome.org/browse/gtk+/tree/docs/CODING-STYLE#n458

	“Every file must include config.h first, then its own header, then other
	GTK+ headers that it needs, then system and third-party headers that it
	needs.”

	For the “other GTK+ headers” part, I took the liberty of using the order
	I normally follow, which is GLib headers followed by GIO ones followed
	by GTK+ ones. I use this as it follows their order in the software stack

2017-05-26  Daniel Boles  <dboles.src@gmail.com>

	gtk-demo/demowindow: Use size_t to index in arrays

	int or unsigned int are not guaranteed to be wide enough. Of course,
	that will not matter in many practical cases, but it is better style to
	always use std::size_t when the purpose is to index into an array.

2017-05-26  Daniel Boles  <dboles@src.gnome.org>

	gtk-demo/demowindow: Use auto

2017-05-26  Daniel Boles  <dboles@src.gnome.org>

	gtk-demo: Don’t remove_page() with invalid index

	The decrement was in the iteration expression, so it happened after the
	loop body. So on the first iteration, this would call remove_page() with
	i == get_n_pages(), which is of course 1 past the maximal allowed index.

2017-05-10  Daniel Boles  <dboles.src@gmail.com>

	TreeView: Remove an obsolete comment

	Commit 4504487c7 replaced the old C syntax (void*)0 with nullptr but did
	not remove this comment, which referred to the original cast expression.

2017-05-10  Daniel Boles  <dboles@src.gnome.org>

	Box: Fix comments on constructor

	• typo in internal comment
	• wrong claim that it always creates a horizontal Box in documentation
	comment – looks like a copy-and-paste error from the HBox/VBox days.

2017-05-10  Daniel Boles  <dboles.src@gmail.com>

	CellLayout: Improve docs of get_first_cell() funcs

	They included the line “This assumes that the CellLayout contains only
	one CellRenderer.” But that doesn’t matter: these methods always return
	the first cell, without caring whether there are any others, and thus
	users can call them without caring too. So, that comment had no purpose.

	Also, these are ‘safe’ to call for Layouts containing no cells, in the
	sense that they will return nullptr, so we might as well clarify that.

2017-05-10  Daniel Boles  <dboles.src@gmail.com>

	TreeModel: Improve docs of foreach*() functions

	• Fix example slots to have the correct bool return type; they were void
	• Don’t use example as 1st paragraph as it ends with ;. which looks odd
	• Open by explaining what the typedef is for, with link to its foreach()
	• For each foreach*(), name and link to its type of slot in the comment
	• Use the actual function name in each case, instead of always foreach()

2017-03-27  Daniel Boles  <dboles@src.gnome.org>

	FileChooserDialog: Use static_cast, not C cast

	static_cast is better C++ style and safer due to compile-time checking.

	https://bugzilla.gnome.org/show_bug.cgi?id=780004

2017-03-27  Daniel Boles  <dboles@src.gnome.org>

	FileChooserDialog: Drop unneeded explicit on ctor

	This is only useful to us if the constructor can be invoked with one
	argument (i.e. it only has 1, or the subsequent have default values).
	That is not true here, so the explicit keyword is a semantic mistake.

	https://bugzilla.gnome.org/show_bug.cgi?id=780004

2017-03-27  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	Gtk::FileChooserDialog: Deprecate ctors with backend parameter

	gtk_file_chooser_dialog_new_with_backend() was deprecated in gtk+ 2.14
	and removed in gtk+-3. The corresponding ctors in FileChooserDialog should
	have been removed in gtkmm-3.

2017-02-02  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	Gdk::Window: Deprecate process[_all]_updates()

	gdk_window_process_all_updates() and gdk_window_process_updates()
	have been deprecated in gtk+-3.

2017-01-04  Chun-wei Fan  <fanchunwei@src.gnome.org>

	Visual Studio builds: Fix projects

	Add the missed source files and headers for the projects and
	"installation".

2016-12-31  Daniel Boles  <dboles@src.gnome.org>

	label.ccg: update align args to match doc fix @ hg

	https://bugzilla.gnome.org/show_bug.cgi?id=774652

2016-11-21  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	Gtk::Frame: Fix the documentation of set_label_align()

	Bug 774249

2016-11-19  djb  <db0451@gmail.com>

	Label: improve h/valign constructor doc comment

	https://bugzilla.gnome.org/show_bug.cgi?id=774652

2016-11-19  djb  <db0451@gmail.com>

	Label(): don't use misleading align argument names

	These arguments are forwarded to set_halign() and set_valign(), yet they
	were named xalign and yalign, which is especially confusing because
	Label already has completely separate xalign and yalign properties.
	This could lead to users getting confused when they think they're
	setting one of these pairs of properties but actually setting the other.

	https://bugzilla.gnome.org/show_bug.cgi?id=774652

2016-11-05  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	Gtk::Widget: Deprecate is_composited() and signal_composited_changed()

	because they are deprecated in gtk+-3. Bug #773642.

2016-10-31  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	Deprecate API which is deprecated in gtk+-3

	* gdk/src/screen.[ccg|hg]:
	* gdk/src/visual.hg:
	* gdk/src/window.hg:
	* gtk/src/menu.[ccg|hg]:
	* gtk/src/widget.hg:
	* gtk/src/window.hg: Deprecate many methods.
	* gtk/src/container.hg: Deprecate property_child(). Bug #773642.

2016-10-31  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	GtkMainConnectionNode: Remove unused method

	* gtk/src/main.ccg: destroy_notify_handler() in the local GtkMainConnectionNode
	class is not used. gcc 6.2 reports that as an error when building
	with --enable-warnings=fatal. Remove the unused method.

2016-09-22  Murray Cumming  <murrayc@murrayc.com>

	Gdk::Pixbuf: Add commented-out get_pixels(length&) with TODO.

	We can uncomment this after we branch.

2016-09-20  Murray Cumming  <murrayc@murrayc.com>

	3.22.0

2016-09-14  Murray Cumming  <murrayc@murrayc.com>

	3.21.6

2016-09-14  Murray Cumming  <murrayc@murrayc.com>

	ScrolledWindow: Added get/set_propagate_natural_height/width().

	And the properties.

2016-09-14  Murray Cumming  <murrayc@murrayc.com>

	Gdk::PixbufFormat: Added is_save_option_supported().

2016-09-14  Murray Cumming  <murrayc@murrayc.com>

	Gdk::Pixbuf: Add copy_options().

2016-09-14  Murray Cumming  <murrayc@murrayc.com>

	Pixbuf: Add set_option() and remove_option().

	gdk_pixbuf_set_option() was previously for use only in backend code,
	but now it is available to client code too:
	https://git.gnome.org/browse/gdk-pixbuf/commit/gdk-pixbuf/gdk-pixbuf-core.h?id=6b75ef95f5d26a2958b77c00a7f7cc22e74cb36c

2016-09-12  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	Gtk::TreeNodeChildren: Deprecate the reverse iterator

	* gtk/src/treeiter.hg:
	* gtk/src/treemodel.hg: Deprecate Gtk::TreeNodeChildren::reverse_iterator.
	It has never worked and it's difficult to fix. Even if fixed, it would
	probably be used very seldom. Bug #554889

2016-09-10  Murray Cumming  <murrayc@murrayc.com>

	Regenerate *docs.xml files.

2016-09-10  Murray Cumming  <murrayc@murrayc.com>

	Regenerate gtk .defs.

2016-09-10  Murray Cumming  <murrayc@murrayc.com>

	Regenerate gdk .defs.

2016-08-19  Murray Cumming  <murrayc@murrayc.com>

	Popover: Add popup() and popupdown().

	Deprecating get/set_transitions_enabled().

2016-08-19  Murray Cumming  <murrayc@murrayc.com>

	Regenerate GTK+ .defs.

2016-08-11  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	Gtk::Clipboard::wait_for_uris(): Fix the documentation

	The description of the return value was not very good, when it was copied
	from the gtk+ doc, and it got worse when gmmproc started removing
	sentences with "g_strfreev".

2016-08-07  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	Gtk::RadioMenuItem, RadioToolButton: Add join_group()

	* demos/gtk-demo/example_iconbrowser.cc: Use join_group().
	* gtk/src/radiobutton.hg: Add property_group().
	* gtk/src/radiomenuitem.[ccg|hg]:
	* gtk/src/radiotoolbutton.[ccg|hg]: Add join_group(), constructors without
	a RadioButtonGroup parameter, and property_group(). Bug #769374

2016-08-05  Murray Cumming  <murrayc@murrayc.com>

	Tiny whitespace change.

2016-08-01  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	Add the Gtk::ShortcutLabel widget

	* .gitignore: Add new generated .h and .cc files.
	* gtk/gtkmm.h: Add the shortcutlabel.h file.
	* gtk/src/filelist.am: Add the shortcutlabel.hg file.
	* gtk/src/shortcutlabel.[hg|ccg]: New files.

2016-08-01  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	Regenerate gtk_signals.defs

	tools/extra_defs_gen/generate_defs_gtk.cc: Add GTK_TYPE_SHORTCUT_LABEL.
	gtk/src/gtk_signals.defs: Regenerate.

2016-08-01  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	Gtk::FileChooser, Menu, ScrolledWindow: Wrap new methods

	* gtk/src/filechooser.[ccg|hg]: Add the 'choice' methods.
	* gtk/src/menu.hg: Add popped_up_*() methods and signal, and new properties.
	* gtk/src/scrolledwindow.hg: Add max_content_width/height() methods and
	properties.
	* gtk/src/targetlist.hg: _IGNORE(gtk_target_list_add_table). It has been
	wrapped in a hand-coded method for a long time.

2016-08-01  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	Gtk: Regenerate docs.xml and the .defs files

2016-08-01  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	Wrap enum GdkAnchorHints

	enum Gtk::AnchorHints is used in a new property in Gtk::Menu.

2016-08-01  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	Gdk: Regenerate docs.xml and the .defs files

2016-07-21  Murray Cumming  <murrayc@murrayc.com>

	3.21.4

2016-07-18  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	Build: Fix silent builds

	* configure.ac: Pass yes to AM_SILENT_RULES, thus enabling silent builds.
	* docs/reference/Doxyfile.in: Set QUIET=YES.
	Update for doxygen 1.8.11 (not necessary for silent builds).
	Bug #768797

2016-07-16  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	Improve the documentation of deprecation

	Improve the documentation of replacements for the deprecated classes
	Gtk::UIManager, ActionGroup, Activatable, RadioAction, RecentAction and
	ToggleAction. Gtk::Action was well documented in the previous commit.
	Bug #768573.

2016-07-13  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	Deprecate Gtk::UIManager, Gtk::Action etc.

	Deprecate Gtk::UIManager, Gtk::Action (almost), ActionGroup,
	Activatable (almost), RadioAction, RecentAction and ToggleAction.
	The corresponding gtk+ classes have been deprecated since gtk+ 3.10.
	Activatable can't be completely deprecated because it's a base class of some
	widgets. Gtk::Action can't be completely deprecated (at least not without
	complications) because it's used in virtual methods in Activatable.
	Bug #768573.

2016-06-30  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	Gtk::FlowBox, ListBox: Include glibmm/exceptionhandler.h

	That's where Glib::exception_handlers_invoke() is declared.

2016-06-30  Kjell Ahlstedt  <kjell.ahlstedt@bredband.net>

	Gtk::FlowBox, ListBox: Add bind_model() and bind_list_store()

	Most of ListBox::bind_model() by Murray Cumming <murrayc@murrayc.com>
	Bug #755149
